# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *



def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()
    app_name = control.name

    download_dict = {
        "windows": "https://eshare.app/app/msi",
        "darwin": "https://eshare.app/macclient.php",
    }

    if control.target_os == "windows":
        download_url = requests.head(download_dict[control.target_os], allow_redirects=True, proxies=proxies).url
    else:
        download_url = requests.head(download_dict[control.target_os], proxies=proxies).headers['Location']

    latest_bin = download_url.rsplit('/', 1)[-1]
    latest_bin_extension = latest_bin.rsplit('.', 1)[-1]
    version = latest_bin.rsplit('_', 1)[-1].replace("v", "").replace(f".{latest_bin_extension}", "")

    # Downloading latest binaries
    print(f"Latest {app_name} version is: {version}")
    print(f"Download URL is: {download_url}")
    if not isfile(latest_bin):
        print(f"Downloading: {latest_bin}")
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print(f"Binary is present: {latest_bin}")

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print(f"Software version updated (from: {control.get_software_version()} to: {Version(version)})")
        package_updated = True
    else:
        print(f"Software version up-to-date ({Version(version)})")

    for f in glob.glob(f'*.{latest_bin_extension}'):
        if f != latest_bin:
            remove_file(f)

    control.set_software_version(version)
    control.save_control_to_wapt()

    return package_updated